<?php

namespace Omnipay\Helcim\Message;

//use Omnipay\Common\Message\AbstractResponse;

/**
* Helcim Hosted Pages Complete Authorize Response
* Used by both authorize and purchase.
*/
class HostedPagesCompleteResponse extends AbstractResponse
{
    /**
     * Check if the response from the Hosted Pages indicates a successful authorisation.
     */
    public function isSuccessful()
    {
        // 1 = approved, 0 = declined
        return isset($this->data['response']) && $this->data['response'] == "1";
    }

    /**
     * This is the unique transaction ID generated by helcim.
     */
    public function getTransactionReference()
    {
        return isset($this->data['transactionId']) ? $this->data['transactionId'] : null;
    }

    /**
     * The notice contains warnings that the form may have generated, but which did not prevent
     * the payment being authorised.
     * The notices will be an array of text messages.
     */
    public function getNotice()
    {
        return isset($this->data['notice']) ? preg_split('/[\n\r]+/', $this->data['notice']) : array();
    }

    /**
     * Any custom fields the form may have POSTed.
     * This is the only point the application will get to capture them, so be fast.
     * The custom fields are an array keyed on the field name.
     * Checkbox type custom fields will be an array of selected checkbox values.
     */
    public function getCustom()
    {
        return isset($this->data['custom']) ? $this->data['custom'] : array();
    }
}
