# Omnipay: Komoju

**Komoju driver for the Omnipay PHP payment processing library**

[![Build Status](https://travis-ci.org/dannyvink/omnipay-komoju.svg?branch=master)](https://travis-ci.org/dannyvink/omnipay-komoju)
[![Latest Stable Version](https://poser.pugx.org/vink/omnipay-komoju/v/stable)](https://packagist.org/packages/vink/omnipay-komoju)
[![Total Downloads](https://poser.pugx.org/vink/omnipay-komoju/downloads)](https://packagist.org/packages/vink/omnipay-komoju)
[![License](https://poser.pugx.org/vink/omnipay-komoju/license)](https://packagist.org/packages/vink/omnipay-komoju)

[Omnipay](https://github.com/thephpleague/omnipay) is a framework agnostic, multi-gateway payment
processing library for PHP 5.3+. This package implements [Komoju](http://komoju.com) support for Omnipay.

## Installation

Omnipay is installed via [Composer](http://getcomposer.org/). To install, simply add it
to your `composer.json` file:

```json
{
    "require": {
        "vink/omnipay-komoju": "~1.0"
    }
}
```

And run composer to update your dependencies:

    $ curl -s http://getcomposer.org/installer | php
    $ php composer.phar update

## Basic Usage

The following gateways are provided by this package:

* Komoju

For general usage instructions, please see the main [Omnipay](https://github.com/thephpleague/omnipay) repository.

## Support

If you are having general issues with Omnipay, we suggest posting on
[Stack Overflow](http://stackoverflow.com/). Be sure to add the
[omnipay tag](http://stackoverflow.com/questions/tagged/omnipay) so it can be easily found.

If you believe you have found a bug, please report it using the [GitHub issue tracker](https://github.com/dannyvink/omnipay-komoju/issues),
or better yet, fork the library and submit a pull request.